<?php 
/**
 * READ THE README! That's where all the answers to all your questions are!
 *
 * This plugin lets you ask visitors a customizable question before comments 
 * are accepted. Inspired by an old hack of mine, and realized as a plugin by 
 * deconstructing the captcha_img plugin, this is 100% open source - released 
 * under the same license as b2evolution itself.  Please be kind and leave a 
 * crediting link to me if you use the code to develop something new, but it 
 * most certainly doesn't need to be a publicly available credit.
 *
 * I'm EdB {@link http://wonderwinds.com/} and I approve this message
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

class turingtest_plugin extends Plugin {
	var $name = 'Turing Test';
	var $code = 'turingtest';
	var $priority = 10;
	var $version = '4.0.1';
	var $author = 'EdB';
	var $help_url = 'http://wonderwinds.com/hackblog.php';
	var $group = 'antispam';
	var $number_of_installs = 1;
	var $apply_rendering = 'never';

/* Fire it up */
function PluginInit( & $params ) {
	$this->short_desc = T_('Stop spammers with a simple question.');
	$this->long_desc = T_('The admin picks a question and an answer that commenters or message form users must answer in order to leave a comment or send a message.  The admin can give a "free pass" to registered bloggers or previous commenters with a simple setting.  In v0.3 you can set a second question and answer challenge for people who register for your blog.');
	}

	function GetDefaultSettings( & $params) {
		return array(
			'question' => array(
				'label' => T_('Question'),
				'defaultvalue' => 'What multi-lingual multi-user multi-blog open source app powers this blog?',
				'type' => 'text',
				'size' => 80,
				'maxlength' => 120,
				'note' => T_('For comments and message forms'),
				'id' => $this->classname.'question',
				),
			'answer' => array(
				'label' => T_('Answer'),
				'defaultvalue' => 'b2evolution',
				'type' => 'text',
				'size' => 32,
				'maxlength' => 32,
				'note' => T_('For comments and message forms'),
				'id' => $this->classname.'answer',
				),
			'answer_label' => array(
				'label' => T_('Answer Label'),
				'defaultvalue' => 'Answer',
				'type' => 'text',
				'size' => 16,
				'maxlength' => 16,
				'note' => T_('For comments and message forms'),
				'id' => $this->classname.'answer_label',
				),
			'reject' => array(
				'label' => T_('Reply if Wrong'),
				'defaultvalue' => 'wrong answer',
				'type' => 'text',
				'size' => 80,
				'maxlength' => 120,
				'note' => T_('For comments and message forms'),
				'id' => $this->classname.'reject',
				),
			'pass' => array(
				'label' => T_('Free Pass'),
				'defaultvalue' => 'commenters',
				'type' => 'select',
				'options' => array( 'noone' => T_('No one'), 'registered' => T_('Registered Members'), 'commenters' => T_('Previous Commenters') ),
				'note' => T_('For comments and message forms'),
				'id' => $this->classname.'pass',
				),
			'question_R' => array(
				'label' => T_('Registration Q'),
				'defaultvalue' => 'What multi-lingual multi-user multi-blog open source app powers this blog?',
				'type' => 'text',
				'size' => 80,
				'maxlength' => 120,
				'note' => T_('For registrations'),
				'id' => $this->classname.'question_R',
				),
			'answer_R' => array(
				'label' => T_('Registration A'),
				'defaultvalue' => 'b2evolution',
				'type' => 'text',
				'size' => 32,
				'maxlength' => 32,
				'note' => T_('For registrations'),
				'id' => $this->classname.'answer_R',
				),
			'answer_R_label' => array(
				'label' => T_('Registration A L'),
				'defaultvalue' => 'Answer',
				'type' => 'text',
				'size' => 16,
				'maxlength' => 16,
				'note' => T_('For registrations'),
				'id' => $this->classname.'answer_R_label',
				),
			'reject_R' => array(
				'label' => T_('Registration RiW'),
				'defaultvalue' => 'wrong answer',
				'type' => 'text',
				'size' => 80,
				'maxlength' => 120,
				'note' => T_('For registrations'),
				'id' => $this->classname.'reject_R',
				),
			);
		}

	function DisplayCommentFormFieldset( & $params ) {
		$tur_test_answer = '';
		switch( $this->Settings->get( 'pass' ) ) {
			case 'noone':
			break;
			case 'registered':
			if( is_logged_in() ) {
				$tur_test_answer = $this->Settings->get( 'answer' );
				}
			break;
			case 'commenters':
			$name_cookie_exists = isset($_COOKIE['cookieb2evoname']) ? true : false;
			if( (is_logged_in()) || ($name_cookie_exists) ) {
				$tur_test_answer = $this->Settings->get( 'answer' );
				}
			break;
			}
		$Form = & $params['Form'];
		if( ! isset($params['form_use_fieldset']) || $params['form_use_fieldset'] ) {
			$Form->begin_fieldset();
			}
		echo '<strong>'.$this->Settings->get( 'question' ).'</strong><br />';
		$Form->text_input( 'answer_turing_test', $tur_test_answer, 9, $this->Settings->get( 'answer_label' ), 'The letters are Case sensitive', array( 'maxlength' => 9, 'class' => 'bComment' ) );
		if( ! isset($params['form_use_fieldset']) || $params['form_use_fieldset'] ) {
			$Form->end_fieldset();
			}
		}

	function BeforeCommentFormInsert( & $params ) {
		if( ! empty($params['is_preview']) ) {
			return;
			}
		$submitted_answer = isset($_POST['answer_turing_test']) ? $_POST['answer_turing_test'] : '';
		if( $submitted_answer != $this->Settings->get( 'answer' ) ) {
			$this->msg( $this->Settings->get( 'reject' ), 'error' );
			}
		}

	function DisplayMessageFormFieldset( & $params ) {
		$tur_test_answer = '';
		switch( $this->Settings->get( 'pass' ) ) {
			case 'noone':
			break;
			case 'registered':
			if( is_logged_in() ) {
				$tur_test_answer = $this->Settings->get( 'answer' );
				}
			break;
			case 'commenters':
			$name_cookie_exists = isset($_COOKIE['cookieb2evoname']) ? true : false;
			if( (is_logged_in()) || ($name_cookie_exists) ) {
				$tur_test_answer = $this->Settings->get( 'answer' );
				}
			break;
			}
		$Form = & $params['Form'];
		if( ! isset($params['form_use_fieldset']) || $params['form_use_fieldset'] ) {
			$Form->begin_fieldset();
			}
		echo '<strong>'.$this->Settings->get( 'question' ).'</strong>';
		$Form->text_input( 'answer_turing_test', $tur_test_answer, 32, $this->Settings->get( 'answer_label' ), 'The answer is Case sensitive.', array( 'maxlength' => 32, 'class' => 'bComment' ) );
		if( ! isset($params['form_use_fieldset']) || $params['form_use_fieldset'] ) {
			$Form->end_fieldset();
			}
		}

	function MessageFormSent( & $params ) {
		if( ! empty($params['is_preview']) ) {
			return;
			}
		$submitted_answer = isset($_POST['answer_turing_test']) ? $_POST['answer_turing_test'] : '';
		if( $submitted_answer != $this->Settings->get( 'answer' ) ) {
			$this->msg( $this->Settings->get( 'reject' ), 'error' );
			}
		}

	function DisplayRegisterFormFieldset( & $params ) {
		$tur_test_answer = '';
		$Form = & $params['Form'];
		if( ! isset($params['form_use_fieldset']) || $params['form_use_fieldset'] ) {
			$Form->begin_fieldset();
			}
echo '<strong>'.$this->Settings->get( 'question' ).'</strong><br />';
		$Form->text_input( 'answer_turing_test', $tur_test_answer, 9, $this->Settings->get( 'answer_label' ), 'The letters are Case sensitive', array( 'maxlength' => 9, 'class' => 'bComment' ) );
		if( ! isset($params['form_use_fieldset']) || $params['form_use_fieldset'] ) {
			$Form->end_fieldset();
			}
		}

	function RegisterFormSent( & $params ) {
		$submitted_answer = isset($_POST['answer_turing_test_R']) ? $_POST['answer_turing_test_R'] : '';
		if( $submitted_answer != $this->Settings->get( 'answer_R' ) ) {
			$this->msg( $this->Settings->get( 'reject_R' ), 'error' );
			}
		}

	}

?>
